// class TimeLogger {
//     constructor() {
//         this.logs = [];
//         this.unlabelled_id = 0;
//         this.start = this.previous = Date.now();
//         this.log('start');
//     }
//     log(label) {
//         var now = Date.now();
//         var log = {
//             'when': now,
//             'label': label,
//             'elapsed': now - this.previous,
//             'total': now - this.start
//         };
//         this.logs.push(log);
//         this.previous = now;
//         return log;
//     }
// }

// const timelogger = new TimeLogger;
// console.log(timelogger.logs[0]);
//
// console.log(timelogger.log("post-data"));

// Settings

function StockedSetting(name, charredSettingData) {
    this.isSubsetting = false;
    if(result = name.match(/(.*) setting/i)) {
        this.name = result[1];
    } else if(result = name.match(/(.*) subsetting/i)) {
        this.name = result[1];
        this.isSubsetting = true;
    } else {
        this.name = name;
    }
    this.lifepaths = [];
    for (let name in charredSettingData) {
        this.lifepaths.push(new StockedLifePath(name, charredSettingData[name]));
    }
}
StockedSetting.prototype.addLifepath = function() {
    this.lifepaths.push(new StockedLifePath(this.newLifepathName, {}));
    this.newLifepathName = "";
}
StockedSetting.prototype.removeLifepath = function(index) {
    this.lifepaths.splice(index, 1);
}
StockedSetting.prototype.toCharred = function() {
    // let name = this.name + (this.isSubsetting ? " Subsetting" : " Setting";

    let charred = {};
    for(let lp of this.lifepaths) {
        charred[lp.name] = lp.toCharred();
    }
    // common traits
    // stride
    return charred;
}

function StockedLifePath(name, charredPathData) {
    if(charredPathData) {
        this.name     = name;
        this.time     = charredPathData.time;
        this.res      = charredPathData.res;
        this.requires = charredPathData.requires;
        this.restrict = charredPathData.restrict;
        this.stat     = new StockedLifePathStats(charredPathData.stat);
        this.skills   = new StockedLifePathSkills(charredPathData.skills);
        this.traits   = new StockedLifePathTraits(charredPathData.traits);
    } else {
        this.stat     = new StockedLifePathStats();
        this.skills   = new StockedLifePathSkills();
        this.traits   = new StockedLifePathTraits();
    }

    this.leads_dict = {};
    if(charredPathData.leads) {
        for(let lead of charredPathData.leads) { this.leads_dict[lead] = true; }
    }
    this.leads = () => Object.keys(this.leads_dict).filter(l => this.leads_dict[l]);
}
StockedLifePath.prototype.toCharred = function() {
    let charred = {};
    charred.time     = this.time;
    charred.res      = this.res;
    charred.requires = this.requires;
    charred.restrict = this.restrict;
    charred.stat     = this.stat.toCharred();
    charred.skills   = this.skills.toCharred();
    charred.traits   = this.traits.toCharred();
    charred.leads    = this.leads();
    return charred;
}

function StockedLifePathStats(charredStatData) {
    this.P = 0;
    this.M = 0;
    this.PM = 0;
    if(charredStatData) {
        for (let stat of charredStatData) {
            if(stat[1].toUpperCase() == 'P') {
                this.P += stat[0];
            }
            else if(stat[1].toUpperCase() == 'M') {
                this.M += stat[0];
            }
            else if(stat[1].toUpperCase() == 'PM' || stat[0].toUpperCase() == 'MP') {
                this.PM += stat[0];
            }
        }
    }
}
StockedLifePathStats.prototype.toString = function() {
    let strs = [];
    if (this.P) { strs.push("+" + this.P + "P"); }
    if (this.M) { strs.push("+" + this.M + "M"); }
    if (this.PM) { strs.push("+" + this.PM + "P/M"); }
    return strs.join(",");
};
StockedLifePathStats.prototype.toCharred = function() {
    let charred = [];
    if(this.P > 0) charred.push([this.P, "p"]);
    if(this.M > 0) charred.push([this.M, "m"]);
    if(this.PM > 0) charred.push([this.PM, "pm"]);
    return charred;
}

function StockedLifePathSkills(charredLpSkillData) {
    this.lpPoints = 0;
    this.generalPoints = 0;
    this.lpSkills = [];
    if (charredLpSkillData) {
        for (let skill of charredLpSkillData) {
            if(skill.length == 1) {
                this.lpPoints = skill[0];
            }
            if(skill.length >= 2) {
                if(skill[1].toLowerCase() == "general") {
                    this.generalPoints += skill[0];
                } else {
                    this.lpPoints += skill[0];
                    this.lpSkills = this.lpSkills.concat(skill.slice(1));
                }
            }
        }
    }
}
StockedLifePathSkills.prototype.removeSkill = function(index) {
    this.lpSkills.splice(index, 1);
}
StockedLifePathSkills.prototype.addSkill = function(skill) {
    this.lpSkills.push(skill);
}
StockedLifePathSkills.prototype.toString = function() {
    let strs = [];
    if (this.lpPoints) { strs.push(StockedUtil.pts(this.lpPoints, this.lpSkills)); }
    if (this.generalPoints) { strs.push(StockedUtil.pts(this.generalPoints, ["General"])); }
    return strs.join("; ");
};
StockedLifePathSkills.prototype.toCharred = function() {
    let charred = [];
    if(this.lpSkills.length > 0 || this.lpPoints > 0){
        charred.push([this.lpPoints].concat(this.lpSkills));
    }
    if(this.generalPoints > 0)
        charred.push([this.generalPoints, "General"]);
    return charred;
}

function StockedLifePathTraits(charredTraitData) {
    this.lpTraits = [];
    if(charredTraitData) {
        this.points = charredTraitData[0];
        this.lpTraits = charredTraitData.slice(1);
    }
}
StockedLifePathTraits.prototype.removeTrait = function(index) {
    this.lpTraits.splice(index, 1);
}
StockedLifePathTraits.prototype.addTrait = function(skill) {
    this.lpTraits.push(skill);
}
StockedLifePathTraits.prototype.toString = function() {
    return StockedUtil.pts(this.points, this.lpTraits);
}
StockedLifePathTraits.prototype.toCharred = function() {
    return [this.points].concat(this.lpTraits);
}


// Skills

function StockedSkill(name, charredSkillData) {
    this.name = name;
    this.magic = charredSkillData.magic ? true : false;
    this.roots = {
        Perception: false,
        Will: false,
        Forte: false,
        Power: false,
        Agility: false,
        Speed: false,
    };
    if(charredSkillData.roots){
        charredSkillData.roots.map(rootName => this.roots[rootName] = true);
    }
    this.stockSpecific = "TODO";
}

// Traits

function StockedTrait(name, charredTraitData) {
    this.name = name;
    this.cost = charredTraitData.cost;
    this.type = charredTraitData.type;
    this.desc = charredTraitData.desc;

    // No logic for these yet
    this.bonus = charredTraitData.bonus;
    this.restrict = charredTraitData.restrict;
}

//Ctrl

var testscope;

function StockedCtrl($scope, $http, burningData) {
    $scope.to_id = function(input) { return input.replaceAll(/\W/g, '_'); };
    $scope.StockedUtil = StockedUtil;

    $scope.TRAIT_TYPES = ["character", "die", "call_on"];

    $scope.settings = [];

    /* testing */
    testscope = $scope;
    $scope.general = {
        'Name': 'Foo',
        'Stride': 7,
        'CommonTraits': [],
        'selectedTrait': ''
    };

    // $scope.parseStock = function (stockData){
    //     let settings = [];
    //     for (let name in stockData) {
    //         settings.push(new StockedSetting(name, stockData[name]));
    //     }
    //     return settings;
    // };

    // $scope.parseSkills = function (skillsData){
    //     let skills = [];
    //     for (let name in skillsData) {
    //         skills.push(new StockedSkill(name, skillsData[name]));
    //     }
    //     return skills;
    // };

    // $scope.parseTraits = function (traitsData){
    //     let traits = [];
    //     for (let name in traitsData) {
    //         traits.push(new StockedTrait(name, traitsData[name]));
    //     }
    //     return traits;
    // };

    /* end testing */

    /* Input/Output */
    /* end Input/Output */

    $scope.addSetting = function (){
        this.settings.push(new StockedSetting(this.newSettingName, {}));
        this.newSettingName = "";
    };

    $scope.removeSetting = function (index) {
        this.settings.splice(index, 1);
    };

    $scope.addSkill = function (){
        this.skills.push(new StockedSkill("New", {}));
    };
    $scope.removeSkill = function (index) {
        this.skills.splice(index, 1);
    };

    $scope.addTrait = function (){
        this.traits.push(new StockedTrait("New", {}));
    };
    $scope.removeTrait = function (index) {
        this.traits.splice(index, 1);
    };

    $scope.collapseBody = function(data_target, $event) {
        $(data_target).collapse("toggle");
        if($event) { $event.stopPropagation(); }
    };
    $scope.editField = function($event, edit) {
        $($event.target).toggleClass("not-editing");
    };
    burningData.registerOnAllDatasetsLoaded(function() {
        onLifepathsLoad_Stocked($scope, burningData);
    });

    $scope.editLeads = function($event) {
        let container = $($event.target).closest('.path-leads');
        container.find(".path-leads-read").toggle(false);
        container.find(".path-leads-write").toggle(true);
    };
    $scope.readLeads = function($event) {
        let container = $($event.target).closest('.path-leads');
        container.find(".path-leads-read").toggle(true);
        container.find(".path-leads-write").toggle(false);
    };

    $scope.stocked_loadCharredModel = function() {
        file = document.getElementById("stocked_charred_file");
        file.files[0].text().then((text) => loadCharredModel(this, JSON.parse(text)));
    };
    $scope.stocked_downLoadCharredModel = function() {
        model = serializeToCharredModel(this);
        $http.post("/stocked_download", model).
            success(function(data,status,headers,config){
                console.log("huzzah, converting stocked model to charred succeeded. File URL: " + data);
                var frame = document.getElementById("downloadframe");
                if ( frame ){
                    frame.src = data;
                }
            }).
            error(function(data,status,headers,config){
                console.log("boo, converting stocked model to charred failed. File URL: " + data);
                $scope.addAlert('tools', "converting stocked model to charred failed: " + data);
            });
    }
}

// Accepts an object, JSON text should be parsed first
function loadCharredModel($scope, model) {
    let settings = [];
    for (let name in model) {
        settings.push(new StockedSetting(name, model[name]));
    }
    $scope.settings = settings;
    $scope.$apply();
}

function serializeToCharredModel($scope) {
    let model = {};
    model.settings = {};
    model.Name = $scope.general.Name;
    $scope.settings.forEach((s) =>
        model.settings[s.name + (s.isSubsetting ? " Subsetting" : " Setting")] = s.toCharred())
    return JSON.stringify(model);
}

function onLifepathsLoad_Stocked($scope, burningData) {
//     $scope.settings = $scope.parseStock(test_data);
//     $scope.skills = $scope.parseSkills(test_skills_data);
//     $scope.traits = $scope.parseTraits(test_traits_data);
    $scope.charredTraits = Object.keys(burningData.traits);
    $scope.charredSkills = Object.keys(burningData.skills);
}

var StockedUtil = {
    "pluralize": function(num, thing, withE, nospace) {
        str = "";
        str += num;
        if (!nospace) { str += ' '; }
        str += thing;
        if(num != 1) {
            if (withE) { str += 'e'; }
            str += 's';
        }
        return str;
    },
    "pts": function(num, entries) {
        let str = StockedUtil.pluralize(num, "pt") + ": ";
        if(Array.isArray(entries) && entries.length > 0) { str += entries.join(", "); }
        else { str += "—" }
        return str;
    }//, "filter$properties": (key, value) => (key.startsWith('$') ? undefined : value)

};
